## rock-master-20.06-slam-envire 0.20200806

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
find_package(Rock)


rock_init(envire 1.0)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

rock_find_pkgconfig(EIGEN3 eigen3 REQUIRED)
find_package(Boost REQUIRED COMPONENTS filesystem thread system regex program_options)
include_directories(${Boost_INCLUDE_DIRS})

rock_activate_cxx11()

option( USE_CGAL "Switch on CGAL related functionality" OFF )
include(${PROJECT_SOURCE_DIR}/cmake/UseCGAL.cmake)
if (USE_CGAL)
    if (NOT CGAL_FOUND)
        message (FATAL_ERROR "CGAL, BLAS and/or LAPACK could not be found, CGAL will not be used!")
    endif()

    add_definitions( -DENVIRE_USE_CGAL -DCGAL_EIGEN3_ENABLED)    
endif()

rock_export_includedir(${PROJECT_SOURCE_DIR}/src ${PROJECT_NAME})
rock_add_source_dir(icp icp)
rock_standard_layout()
add_subdirectory(tools)

=== icp/CMakeLists.txt ===
rock_library(icp
    icp.cpp
    stability.cpp
    icpLocalization.cpp
    DEPS_CMAKE KDTree Boost
    DEPS_PKGCONFIG base-types)

install(FILES icp.hpp
ransac.hpp
stability.hpp
icpConfigurationTypes.hpp
icpLocalization.hpp
    DESTINATION include/envire)

=== src/CMakeLists.txt ===
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
if( USE_CGAL AND CGAL_FOUND )
    list(APPEND ADDITIONAL_SOURCES 
	operators/SimplifyPointcloud.cpp
	operators/Projection.cpp)

    if( TAUCS_FOUND )
	    list(APPEND ADDITIONAL_SOURCES operators/SurfaceReconstruction.cpp)
    endif( TAUCS_FOUND )
endif()

rock_add_public_dependencies(envire
    CMAKE GDAL)

rock_library(envire
    core/Environment.cpp
    core/FrameNode.cpp
    core/Transform.cpp
    core/Layer.cpp
    core/Operator.cpp
    core/Serialization.cpp
    core/SerializationFactory.cpp
    core/Event.cpp
    core/EventSource.cpp
    core/EventHandler.cpp
    maps/ElevationGrid.cpp
    maps/Featurecloud.cpp
    maps/GridBase.cpp
    maps/Grids.cpp 
    maps/LaserScan.cpp
    maps/MLSGrid.cpp
    maps/MLSMap.cpp
    maps/MapSegment.cpp
    maps/Pointcloud.cpp
    maps/PolygonMap.cpp
    maps/TraversabilityGrid.cpp
    maps/TriMesh.cpp
    operators/Projection.cpp
    operators/MLSProjection.cpp
    operators/MergeMLS.cpp
    operators/MergePointcloud.cpp
    operators/ObjectGrowing.cpp
    operators/ScanMeshing.cpp
    operators/MLSSlope.cpp
    operators/SimpleTraversability.cpp
    operators/DistanceGridToPointcloud.cpp
    operators/Fold.cpp
    operators/GridFloatToMLS.cpp
    operators/MLSToGrid.cpp
    operators/CutPointcloud.cpp
    operators/GridIllumination.cpp 
    operators/TraversabilityGrassfire.cpp
    operators/TraversabilityGrowClasses.cpp
    operators/MLSToPointCloud.cpp
    tools/BresenhamLine.cpp
    tools/PlyFile.cpp
    tools/RadialLookUpTable.cpp
    tools/BoxLookUpTable.cpp
    tools/GridAccess.cpp
    tools/GraphViz.cpp
    ${ADDITIONAL_SOURCES}
    HEADERS Core.hpp
    DEPS_PKGCONFIG ply base-types base-lib base-logging box2d numeric
    DEPS_CMAKE LibYAML GDAL
    DEPS_PLAIN Boost_SYSTEM Boost_FILESYSTEM Boost_THREAD)

install(FILES core/EventHandler.hpp
    core/Environment.hpp
    core/EnvironmentItem.hpp
    core/Event.hpp
    core/EventHandler.hpp
    core/EventSource.hpp
    core/EventTypes.hpp
    core/Features.hpp
    core/FrameNode.hpp
    core/Holder.hpp
    core/Layer.hpp
    core/Operator.hpp
    core/Serialization.hpp
    core/SerializationFactory.hpp
    core/Transform.hpp
    DESTINATION include/envire/core)

install(FILES 
    maps/ElevationGrid.hpp
    maps/Featurecloud.hpp
    maps/GridBase.hpp
    maps/Grid.hpp
    maps/Grids.hpp
    maps/LaserScan.hpp
    maps/MapSegment.hpp
    maps/MLSGrid.hpp
    maps/MLSPatch.hpp
    maps/MLSConfiguration.hpp
    maps/MLSMap.hpp
    maps/MultiLevelSurfaceGrid.hpp
    maps/Pointcloud.hpp
    maps/PolygonMap.hpp
    maps/TraversabilityGrid.hpp
    maps/TriMesh.hpp
    DESTINATION include/envire/maps)

install(FILES operators/MergeMLS.hpp
    operators/MergePointcloud.hpp
    operators/MLSProjection.hpp
    operators/ObjectGrowing.hpp
    operators/SimpleTraversability.hpp
    operators/TraversabilityGrassfire.hpp
    operators/TraversabilityGrowClasses.hpp
    operators/GridFloatToMLS.hpp
    operators/MLSToGrid.hpp
    operators/MLSSlope.hpp
    operators/DistanceGridToPointcloud.hpp
    operators/Projection.hpp
    operators/ScanMeshing.hpp
    operators/SimplifyPointcloud.hpp
    operators/SurfaceReconstruction.hpp
    operators/ClassGridProjection.hpp
    operators/CutPointcloud.hpp
    operators/GridIllumination.hpp
    operators/MLSToPointCloud.hpp
    DESTINATION include/envire/operators)

install(FILES tools/GraphViz.hpp
    tools/GridAccess.hpp
    tools/Numeric.hpp
    tools/PlyFile.hpp
    tools/GaussianMixture.hpp
    tools/ListGrid.hpp
    tools/ExpectationMaximization.hpp
    tools/BresenhamLine.hpp
    tools/VoxelTraversal.hpp
    tools/RadialLookUpTable.hpp
    DESTINATION include/envire/tools)

if (USE_CGAL AND CGAL_FOUND)
    message(WARNING "Linking boost system libraries to envire, this may lead to conflicting boost versions!")
    target_link_libraries(envire 
	    ${CGAL_LIBRARIES}
	    ${Boost_FILESYSTEM_LIBRARY}
	    ${Boost_THREAD_LIBRARY}
        ${Boost_SYSTEM_LIBRARY}
        ${Boost_THREAD_LIBRARY}
    )
else() 
    target_link_libraries(envire 
	    ${Boost_LIBRARIES})
endif()

=== viz/CMakeLists.txt ===
# compile shared library
rock_vizkit_plugin(envire-viz
    ElevationGridVisualization.cpp
    EnvireEventListener.cpp
    EnvireVisualization.cpp
    FrameNodeManipulator.cpp
    FrameNodeVisualization.cpp
    GridVisualizationBase.cpp
    ImageRGB24Visualization.cpp
    GridVisualization.cpp
    LaserScanVisualization.cpp
    MapSegmentVisualization.cpp
    MLSVisualization.cpp
    PointcloudVisualization.cpp
    TriMeshVisualization.cpp
    TreeViewListener.cpp
    ItemManipulator.cpp
    TraversabilityGridVisualization.cpp
    MOC ItemManipulator.hpp TreeViewListener.hpp EnvireVisualization.hpp MLSVisualization.hpp PointcloudVisualization.hpp EnvireEventListener.hpp ElevationGridVisualization.hpp MapSegmentVisualization.hpp FrameNodeVisualization.hpp GridVisualization.hpp
    DEPS envire
    DEPS_PKGCONFIG base-viz
    HEADERS EnvireVisualization.hpp EnvireEventListener.hpp TreeViewListener.hpp EnvireWidget.hpp
    EnvironmentItemVisualizer.hpp)
target_link_libraries(envire-viz ${Boost_THREAD_LIBRARY})
target_link_libraries(envire-viz pthread)

rock_executable(envireViewer envireViewer.cpp
    DEPS envire-viz
    DEPS_PKGCONFIG vizkit3d)
target_link_libraries(envireViewer
    ${QT_QTGUI_LIBRARY})
    
add_subdirectory(enview)

=== debian/changelog ===
rock-master-20.06-slam-envire (0.20200806-1~buster) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-slam/slam-envire.git
  * branch: refs/heads/master
  * commit: b5f3de5b45af2941fec72dd564fb4e07ef962a35
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Wed, 16 Sep 2020 17:53:32 +0200

=== debian/control ===
Source: rock-master-20.06-slam-envire
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, cmake, libblas-dev, libbox2d-dev, libcgal-dev, libgdal-dev, libkdtree++-dev, liblapack-dev, libyaml-dev, rock-master-20.06-base-cmake, rock-master-20.06-base-logging, rock-master-20.06-base-numeric, rock-master-20.06-base-types, rock-master-20.06-external-libply, rock-master-20.06-gui-vizkit3d
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.06-slam-envire
Architecture: any
Depends: ${shlibs:Depends}, cmake, libblas-dev, libbox2d-dev, libcgal-dev, libgdal-dev, libkdtree++-dev, liblapack-dev, libyaml-dev, rock-master-20.06-base-cmake, rock-master-20.06-base-logging, rock-master-20.06-base-numeric, rock-master-20.06-base-types, rock-master-20.06-external-libply, rock-master-20.06-gui-vizkit3d, ruby
Description: Environment Representation Library
 This library can be used to create a data representation of an environment.
  It works on Cartesian Spaces mostly, but could be extended to topological maps.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := /bin/bash

# BEGIN ENVIRONMENT SETUP
# https://www.debian.org/doc/debian-policy/ch-source.html
# nocheck: This tag says to not run any build-time test suite provided by the package.
DEB_BUILD_OPTIONS  = nocheck
# To disable stripping
#DEB_BUILD_OPTIONS += nostrip
export DEB_BUILD_OPTIONS

# Setup of $(arch), $(rockruby_libdir) and $(rockruby_archdir)
arch=$(shell gcc -print-multiarch)
ruby_ver=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['ruby_version']")
ruby_arch_dir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['archdir']")
ruby_libdir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['rubylibdir']")
rockruby_archdir=$(subst /usr,,$(ruby_arch_dir))
rockruby_libdir=$(subst /usr,,$(ruby_libdir))
# Setup of paths: PATH,PKG_CONFIG_PATH,RUBYLIB,...
master2006_install_dir = /opt/rock/master-20.06
env_setup =  PATH=$(master2006_install_dir)/bin:$$PATH
env_setup += HOME=/home/ 
env_setup += RUBYLIB=$(master2006_install_dir)/$(rockruby_libdir):$(master2006_install_dir)/$(rockruby_archdir):$(master2006_install_dir)/lib/ruby/vendor_ruby/standard:$(master2006_install_dir)/lib/ruby/vendor_ruby/core:$(master2006_install_dir)/lib/ruby/vendor_ruby:$$RUBYLIB
env_setup += PKG_CONFIG_PATH=$(master2006_install_dir)/lib/pkgconfig:$(master2006_install_dir)/lib/$(arch)/pkgconfig:/usr/share/pkgconfig:/usr/lib/$(arch)/pkgconfig:$$PKG_CONFIG_PATH
env_setup += Rock_DIR=$(master2006_install_dir)/share/rock/cmake:$$Rock_DIR
env_setup += LD_LIBRARY_PATH=$(master2006_install_dir)/lib:$(master2006_install_dir)/lib/$(arch):$$LD_LIBRARY_PATH
env_setup += CMAKE_PREFIX_PATH=$(master2006_install_dir):$$CMAKE_PREFIX_PATH
env_setup += OROGEN_PLUGIN_PATH=$(master2006_install_dir)/share/orogen/plugins:$$OROGEN_PLUGIN_PATH
export TYPELIB_CXX_LOADER=castxml
export DEB_CPPFLAGS_APPEND=-std=c++11
export npm_config_cache=/tmp/npm
rock_library_dirs=$(master2006_install_dir)/lib:$(master2006_install_dir)/lib/$(arch):
rock_base_install_dir=/opt/rock
rock_release_install_dir=/opt/rock/master-20.06
rock_install_dir=/opt/rock/master-20.06/rock-master-20.06-slam-envire

# Check if a python command is available and identify the version
# and identify the setup.py file
python_cmd=$(shell command -v python 2> /dev/null)
ifneq ("$(python_cmd)","")
python_version=$(shell python -c 'import sys; print "{0}.{1}".format(sys.version_info[0],sys.version_info[1])')
# Get dirname a setup.py match
python_setup_dir=$(shell find $(DEB_SRCDIR) -name setup.py | tail -n 1 | xargs dirname)
endif

DEB_VERBOSE_ALL=1
include /usr/share/cdbs/1/rules/debhelper.mk

extra_lib_dir=$(shell pwd)/debian/rock-master-20.06-slam-envire$(rock_install_dir)/lib
apaka_libdeps_dirs=`find $(rock_release_install_dir)/* -type d -name lib -exec echo -n ":{}" \;`
# This argument list is forwarded to dh_shlibdeps which takes the -l option and a colon separated list of libraries
# (note that this is different from the linker arguments)
DEB_DH_SHLIBDEPS_ARGS_ALL=-l$(extra_lib_dir):$(extra_lib_dir)/$(arch):$(rock_library_dirs):${apaka_libdeps_dirs}

debian_install_prefix=$(DEB_DESTDIR)$(rock_install_dir)
rock_doc_install_dir=$(rock_install_dir)/share
SOURCE_ENVSH=for file in `find $(rock_release_install_dir)/*/env.sh ! -empty -type f -name env.sh`; do source "$$file"; done;

pre-build::
	echo "Running pre-build"
	echo "Ruby stats"
	echo "   ruby version: $(ruby_ver)"
	echo "   ruby libdir: $(rockruby_libdir)"
	echo "   ruby archdir: $(rockruby_archdir)"
	# Source the available packages
	echo "Sourcing release packages' env.sh"

# END ENVIRONMENT SETUP
######################################
# BEGIN OROGEN -- This block needs to be executed before CMAKE


# END OROGEN
######################################
# BEGIN CMAKE
#
# Defining the cmake command and setting the required enviroment variables
# PKG_CONFIG_PATH Resolve Rock package via pkg-config
# Rock_DIR Set to make sure find_package(Rock) does work
# ROCK_CMAKE_MACROS Used in some patches to set the CMAKE_MODULE_PATH, allowing to find Rock.cmake
CMAKE = $(SOURCE_ENVSH) $(env_setup) cmake
DEB_CMAKE_INSTALL_PREFIX = $(rock_install_dir)

# Debian packaging discourages the use of rpath, but
# cdbs actively sets CMAKE_SKIP_RPATH=ON, so reinforcing OFF here
DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_SKIP_RPATH=OFF
# Telling FindGEM.cmake to search for os packages using pkg-config and not for gems
DEB_CMAKE_EXTRA_FLAGS += -DGEM_OS_PKG=TRUE
# Leaving RUBY_EXECUTABLE unset since it maps to a path of the user executing the upload script
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_EXPORT_COMPILE_COMMANDS="ON" -DCMAKE_BUILD_TYPE="RelWithDebInfo" 
# Disable ROCK Testing -- since running test on the OBS would require proper setting of path, etc. (see. data_processing/type_to_vector)
DEB_CMAKE_EXTRA_FLAGS += -DROCK_TEST_ENABLED=OFF -UROCK_TEST_LOG_DIR
include /usr/share/cdbs/1/class/cmake.mk

# END CMAKE
##########################################
# BEGIN AUTOTOOLS
#


###########################################
# DOCS


# Build docs
# This checks for Doxyfile and runs doxygen with that.
# Otherwise, it tries the "doc" target.
# Since docs are not critical, ignore failures('-' on recipe line start).
# The make call is supposed to be invoked even if -t or -n is selected,
# with the appropriate flags('+' on recipe line start)

common-build-arch common-build-indep:: debian/stamp-rock-doc
debian/stamp-rock-doc:
	-+$(DEB_MAKE_INVOKE) doc
	touch $@

common-install-arch common-install-indep:: common-install-rock-doc install-extensions
common-install-rock-doc::
	mkdir -p $(DEB_DESTDIR)$(rock_doc_install_dir)
	$(if $(wildcard $(DEB_SRCDIR)/doc/html),-cp -r "$(DEB_SRCDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_SRCDIR)/doc),-cp -r "$(DEB_SRCDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))
	$(if $(wildcard $(DEB_BUILDDIR)/doc/html),-cp -r "$(DEB_BUILDDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_BUILDDIR)/doc),-cp -r "$(DEB_BUILDDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))

install-extensions:: install-python
install-python::
ifneq ("$(python_setup_dir)","")
	echo "Installing python extension in $(python_setup_dir)"
	mkdir -p $(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages
	cd $(python_setup_dir); $(python_cmd) setup.py build; PYTHONPATH=$(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages/ $(python_cmd) setup.py install --prefix=$(DEB_DESTDIR)$(rock_install_dir); cd -
endif

clean::
	rm -f debian/stamp-rock-doc
	rm -rf $(DEB_SRCDIR)/doc/html

# END DOCS
###########################################

define export_variable
	find $(debian_install_prefix) -type f -name '*$2' -exec dirname {} + | grep -v CMakeFiles | uniq | xargs -i printf "$1={}:\$${$1}\nexport $1\n" >> $(debian_install_prefix)/env.sh
	sed -i s#$(debian_install_prefix)#$(rock_install_dir)#g $(debian_install_prefix)/env.sh
	find $(debian_install_prefix) -type f -name '*$2' -exec dirname {} + | grep -v CMakeFiles | uniq | xargs -i printf "$1 {}\n" >> $(debian_install_prefix)/env.yml.append
	sed -i s#$(debian_install_prefix)#$(rock_install_dir)#g $(debian_install_prefix)/env.yml.append
endef

#install/rock-master-20.06-slam-envire::
#	echo "Running post-install for package rock-master-20.06-slam-envire"

# see https://github.com/Debian/cdbs/blob/master/1/rules/debhelper.mk.in for
# target
common-binary-fixup-arch::
	echo "Apaka: doing all the custom adaptions, once all patches have been applied"
	echo "Installing env.yml (and env.yml.append) in $(rock_install_dir)"
	$(if $(wildcard $(DEB_SRCDIR)/env.yml),-cp "$(DEB_SRCDIR)/env.yml" "$(DEB_DESTDIR)$(rock_install_dir)")
	$(if $(wildcard $(DEB_SRCDIR)/env.yml.append),-cp "$(DEB_SRCDIR)/env.yml.append" "$(DEB_DESTDIR)$(rock_install_dir)")
	echo "Updating env.sh in $(rock_install_dir)"
	$(if $(wildcard $(DEB_SRCDIR)/env.sh),-cp "$(DEB_SRCDIR)/env.sh" "$(debian_install_prefix)")
